// ueutil.cpp: ueutil NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ueutil.h"
//#include "wince\conv.h"
#include "wince\wince.h"

bool ueutil::b_config;

///////////////////////////////////////////

BOOL ueutil::getExtractPath(char *pathname)
{
	HKEY	hk ;
	LONG	lret ;
	LPBYTE	lpData ;
	DWORD	dwType, cbData ;
	TCHAR t_empty[MAX_PATH];
	LPCTSTR value=t_empty;

	/* WXgL[I[v */
	lret = RegOpenKeyEx( HKEY_CURRENT_USER,
						 _T("Software\\uema2\\XacRettCE"),
						 0,
						 KEY_QUERY_VALUE,
						 &hk ) ;
	if ( lret != ERROR_SUCCESS ) {
		strcpy(pathname, "");
		return FALSE;
	}
	dwType = REG_SZ ;
	lpData = (LPBYTE) value ;
	cbData = MAX_PATH * sizeof (*value) ;
	lret = RegQueryValueEx( hk, _T("ExtractPath"),
		NULL, &dwType, lpData, &cbData ) ;
	RegCloseKey( hk ) ;
	if ( lret != ERROR_SUCCESS ) {
		//s烋[gfBNgԂ
		strcpy(pathname, "");
		return TRUE;
	} else if ( lret == ERROR_MORE_DATA ) {
		//obt@ȂH
		strcpy(pathname, "");
		return TRUE;
	}

	wce_WToA((LPCTSTR)lpData, pathname);
	if( 0==strcmp(pathname, "\\"))
		strcpy(pathname, "");
	return TRUE;
}

BOOL ueutil::setExtractPath(LPCTSTR lpPath)
{
	HKEY	hk ;
	LONG	lret ;
	LPBYTE	lpData ;
	DWORD	ret, dwType, cbData ;
	/* WXgL[쐬 */
	lret = RegCreateKeyEx( HKEY_CURRENT_USER, 
			_T("Software\\uema2\\XacRettCE"),
			0, _T(""), 0,
			0, NULL, &hk, &ret );
	if ( lret != ERROR_SUCCESS ) {
		return FALSE ;
	}

	dwType = REG_SZ ;
	lpData = (LPBYTE) lpPath ;
	cbData = (_tcslen(lpPath) + 1) * sizeof (*lpPath) ;
	lret = RegSetValueEx( hk, _T("ExtractPath"), 
		0, dwType, lpData, cbData ) ;
	RegCloseKey( hk ) ;
	return lret == ERROR_SUCCESS ;
}

bool ueutil::getMakeDirectory()
{
	HKEY hKey;
	LPBYTE lpData;
	DWORD dwSize, dwValue, dwType;
	LONG hRes;

	hRes = RegOpenKeyEx(HKEY_CURRENT_USER,
		_T("Software\\uema2\\XacRettCE"),
		0, KEY_QUERY_VALUE, &hKey);
	if(hRes != ERROR_SUCCESS) return false;

	dwType = REG_DWORD ;
	lpData = (LPBYTE)&dwValue;
	dwSize = sizeof(DWORD)+1;
	hRes = RegQueryValueEx(hKey, _T("MakeDir"),
		0, &dwType, lpData, &dwSize);
	RegCloseKey(hKey);
	if(hRes != ERROR_SUCCESS){
		return false;
	}

	return dwValue==1L?true:false;
	
}

bool ueutil::setMakeDirectory(bool b_ret)
{
	HKEY hKey;
	DWORD dwDisp, dwState;
	LONG hRes;

	hRes = RegCreateKeyEx(HKEY_CURRENT_USER, 
				_T("Software\\uema2\\XacRettCE"), 
				0, L"", 0, 0, NULL, &hKey, &dwDisp);
	if(hRes != ERROR_SUCCESS) return false;
	dwState = b_ret==true?1:0;

	hRes = RegSetValueEx(hKey, _T("MakeDir"),
		0, REG_DWORD, (LPBYTE)&dwState, sizeof(DWORD)+1);
	RegCloseKey(hKey);
	return true;
}

bool ueutil::getOpenDirectory()
{
	HKEY hKey;
	LPBYTE lpData;
	DWORD dwSize, dwValue, dwType;
	LONG hRes;

	hRes = RegOpenKeyEx(HKEY_CURRENT_USER,
				_T("Software\\uema2\\XacRettCE"), 
				0, KEY_QUERY_VALUE, &hKey);
	if(hRes != ERROR_SUCCESS) return false;

	dwType = REG_DWORD ;
	lpData = (LPBYTE)&dwValue;
	dwSize = sizeof(DWORD)+1;
	hRes = RegQueryValueEx(hKey, 
				_T("OpenDir"), 0, &dwType, 
				lpData, &dwSize);
	RegCloseKey(hKey);
	if(hRes != ERROR_SUCCESS){
		return false;
	}

	return dwValue==1L?true:false;
}

bool ueutil::setOpenDirectory(bool b_ret)
{
	HKEY hKey;
	DWORD dwDisp, dwState;
	LONG hRes;

	hRes = RegCreateKeyEx(HKEY_CURRENT_USER, 
				_T("Software\\uema2\\XacRettCE"), 
				0, _T(""), 0, 0, NULL, &hKey, &dwDisp);
	if(hRes != ERROR_SUCCESS) return false;
	dwState = b_ret==true?1:0;

	hRes = RegSetValueEx(hKey, _T("OpenDir"),
				0, REG_DWORD, 
				(LPBYTE)&dwState, sizeof(DWORD)+1);
	RegCloseKey(hKey);
	return true;
}

bool ueutil::getExtractCurrentDir()
{
	HKEY hKey;
	LPBYTE lpData;
	DWORD dwSize, dwValue, dwType;
	LONG hRes;

	hRes = RegOpenKeyEx(HKEY_CURRENT_USER,
				_T("Software\\uema2\\XacRettCE"), 
				0, KEY_QUERY_VALUE, &hKey);
	if(hRes != ERROR_SUCCESS) return false;

	dwType = REG_DWORD ;
	lpData = (LPBYTE)&dwValue;
	dwSize = sizeof(DWORD)+1;
	hRes = RegQueryValueEx(hKey, 
				_T("ExtractCurrentDir"), 0, &dwType, 
				lpData, &dwSize);
	RegCloseKey(hKey);
	if(hRes != ERROR_SUCCESS){
		return false;
	}

	return dwValue==1L?true:false;
}

bool ueutil::setExtractCurrentDir(bool b_ret)
{
	HKEY hKey;
	DWORD dwDisp, dwState;
	LONG hRes;

	hRes = RegCreateKeyEx(HKEY_CURRENT_USER, 
				_T("Software\\uema2\\XacRettCE"), 
				0, _T(""), 0, 0, NULL, &hKey, &dwDisp);
	if(hRes != ERROR_SUCCESS) return false;

	dwState = b_ret==true?1:0;

	hRes = RegSetValueEx(hKey, _T("ExtractCurrentDir"),
				0, REG_DWORD, 
				(LPBYTE)&dwState, sizeof(DWORD)+1);
	RegCloseKey(hKey);
	return true;
}

bool ueutil::replaceExDir(LPCTSTR infile, LPTSTR outdir)
{
	// getExtractPath(char *a);
	// setExtractPath(LPCTSTR lpPath);
	// infile ̃fBNg setExtractPath A
	// ̃fBNg getExtractPath 
	static char dir[MAX_PATH]={0};
	getExtractPath(dir);
	wce_AToW(dir, outdir);

	LPCTSTR p = infile;
	UINT n=_tcslen(infile)-1;
	for(;;)
		if( p[n]==_T('\\') ) break;
		else if( n==0 )      break;
		else                 n--;

	static TCHAR tdir[MAX_PATH]={0};
	if( n==0 )
	{
		 _tcscpy( tdir, _T("\\") );
	}
	else
	{
		_tcsncpy( tdir, infile, n );
		tdir[n]=_T('\0');
	}
	setExtractPath( tdir );
	return true;
}

